/*
    adder.c - A minimal CGI program that adds numbers together.
              This CGI program works with both the GET and the POST methods.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINE 2000

int main()
{
   char *method, *p, *value, *buf_p;
   char buf[MAXLINE];
   char arg[MAXLINE];
   char content[MAXLINE];
   int n[10];
   int nargs = 0;
   int total = 0;
   int i;

   /* Determine the request method */
   method = getenv("REQUEST_METHOD");
   /* Get the query string */
   if ( strcmp(method, "GET") == 0 )
      strcpy(buf, getenv("QUERY_STRING")); // get query string from environment variable
   else if ( strcmp(method, "POST") == 0 )
      scanf("%s", buf);                    // get query string from standard input
   else
      return 1;  // unexpected request method

   buf_p = buf;

   /* Extract the arguments from the query string, (i.e., parse the string) */
   while((p = strchr(buf_p, '=')) != NULL)  // look for a key=value pair
   {
      buf_p = value = p+1; // skip over the key
      if ((p = strchr(buf_p, '&')) != NULL)  // look ahead for another argument pair
      {
         *p = '\0';   // terminate the value string
         buf_p = p+1; // skip the buffer pointer past the value string
      }
      strcpy(arg, value);     // get the value string
      n[nargs++] = atoi(arg); // convert the value string and store the result
   }

   /* Make the response body */
   sprintf(content, "<html>\n");
   sprintf(content, "%s<head>\n", content);
   sprintf(content, "%s<title>Adding numbers</title>\n", content);
   sprintf(content, "%s</head>\n", content);
   sprintf(content, "%s<body>\n", content);
   sprintf(content, "%s<h1>Addition of numbers CGI process</h1>\n", content);
   sprintf(content, "%s<p>\n", content);
   sprintf(content, "%sWelcome to add.com: ", content);
   sprintf(content, "%sTHE Internet addition portal.\r\n<p>", content);
   sprintf(content, "%sThe answer is: ", content);
   for (i = 0; i < nargs; i++)
   {
      sprintf(content, "%s%d ", content, n[i]);
      if (i != nargs-1)
         sprintf(content, "%s+ ", content);
      total += n[i];
   }
   sprintf(content, "%s= %d\r\n<p>", content, total);
   sprintf(content, "%sThanks for visiting!\r\n", content);
   //sprintf(content, "%s<p>nargs = %d.\r\n", content, nargs);
   sprintf(content, "%s</body>", content);
   sprintf(content, "%s</html>", content);

   /* Send the HTTP response lines, followed by a blank line */
   printf("Content-length: %d\r\n", strlen(content));
   printf("Content-type: text/html\r\n\r\n");

   /* Send the response body */
   printf("%s", content);
   fflush(stdout);

   return 0;
}
