/*
    errorLogger.c - A CGI program that sends messages to a log file.
                    This CGI program works with both the GET and the POST methods.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINE 2000

int main()
{
   char *method, *p, *key_p, *value_p, *buf_p;
   char buf[MAXLINE];
   char key[10][20];      // maximum of 10 keys of length 20 characters
   char value[10][20];    // maximum of 10 values of length 20 characters
   char content[MAXLINE];
   int nargs = 0;

   /* Log a message in C:\xampp\apache\logs\error.log */
   fprintf(stderr, "Hello World!");
   fflush(stderr);

   /* Determine the request method */
   method = getenv("REQUEST_METHOD");
   /* Get the query string */
   if ( strcmp(method, "GET") == 0 )
      strcpy(buf, getenv("QUERY_STRING")); // get query string from environment variable
   else if ( strcmp(method, "POST") == 0 )
      scanf("%s", buf);                    // get query string from standard input
   else
      return 1;  // unexpected request method

   buf_p = buf;

   /* Extract the arguments from the query string, (i.e., parse the string) */
   while((p = strchr(buf_p, '=')) != NULL)  // look for a key=value pair
   {
			key_p = buf_p;    // beginning of the key string
			*p = '\0';        // terminate the key string
      value_p = p+1;    // beginning of the value string
      if ((p = strchr(value_p, '&')) != NULL)  // look ahead for another argument pair
      {
         *p = '\0';   // terminate the value string
         buf_p = p+1; // move the buffer pointer past the value string
      }
      strcpy(key[nargs], key_p);     // get the key string
      strcpy(value[nargs], value_p); // get the value string
      nargs++;             // count the number of key=value pairs
   }

   /* Make the response body */
   sprintf(content, "<html>\n");
   sprintf(content, "%s<head>\n", content);
   sprintf(content, "%s<title>Report errors to log file</title>\n", content);
   sprintf(content, "%s</head>\n", content);
   sprintf(content, "%s<body>\n", content);
   sprintf(content, "%s<h1>Reporting messages to a log file</h1>\n", content);
   sprintf(content, "%s<p>\n", content);
   sprintf(content, "%sPlease look in the file\r\n", content);
   sprintf(content, "%s\tC:\\xampp\\apache\\logs\\error.log\r\n<p>", content);
   sprintf(content, "%sYou should see several log messages there from this process.", content);

   /* Log some more messages in C:\xampp\apache\logs\error.log */
   fprintf(stderr, "There are %d argument pairs.", nargs);
   fprintf(stderr, "The first two key=value pairs are %s=%s and %s=%s.", key[0], value[0], key[1], value[1]);
   fflush(stderr);   // this is needed in order to see
                     // the log messages when the program crashes

   sprintf(content, "%s</body>", content);
   sprintf(content, "%s</html>", content);

// int *int_p = NULL;
// *int_p = 0; // crash this process here and see if the log messages still show up

   /* Send the HTTP response lines, followed by a blank line */
   printf("Content-length: %d\r\n", strlen(content));
   printf("Content-type: text/html\r\n\r\n");

// int *int_p = NULL;
// *int_p = 0; // crash this process here and see if the log messages still show up

   /* Send the response body */
   printf("%s", content);
   fflush(stdout);

// int *int_p = NULL;
// *int_p = 0; // crash this process here and see if the log messages still show up

   return 0;
}
