/*
    repeater.c - A minimal CGI program that repeats a word a number of times.
                 This CGI program works with both the GET and the POST methods.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#define MAXLINE 2000

int main()
{
   char *method, *p, *value, *buf_p;
   char buf[MAXLINE];
   char content[MAXLINE];
   char values[10][50];  // 10 arguments of length 50 each
   int nargs = 0;
   int i;

   /* Determine the request method */
   method = getenv("REQUEST_METHOD");
   /* Get the query string */
   if ( strcmp(method, "GET") == 0 )
      strcpy(buf, getenv("QUERY_STRING")); // get query string from environment variable
   else if ( strcmp(method, "POST") == 0 )
      scanf("%s", buf);                    // get query string from standard input
   else
      return 1;  // unexpected request method

   buf_p = buf;

   /* Extract the arguments from the query string, (i.e., parse the string) */
   while((p = strchr(buf_p, '=')) != NULL)  // look for a key=value pair
   {
      buf_p = value = p+1; // skip over the key
      if ((p = strchr(buf_p, '&')) != NULL)  // look ahead for another argument pair
      {
         *p = '\0';   // terminate the value string
         buf_p = p+1; // skip the buffer pointer past the value string
      }
      strcpy(values[nargs++], value);     // get the value string
   }

   /* Make the response body */
   sprintf(content, "<html>\n");
   sprintf(content, "%s<head>\n", content);
   sprintf(content, "%s<title>Repeat a phrase</title>\n", content);
   sprintf(content, "%s</head>\n", content);
   sprintf(content, "%s<body>\n", content);
   sprintf(content, "%s<h1>Repeating a phrase</h1>\n", content);
   sprintf(content, "%s<p>\n", content);
   sprintf(content, "%sWe shall repeat the phrase \"%s\" %d times, very slowly<br>\r\n", content, values[0], atoi(values[1]));
   sprintf(content, "%s(so that you can observe this CGI process using ProcessExplorer)..\r\n<p>", content);
   for (i = 0; i < atoi(values[1]); i++)
   {
      sprintf(content, "%s<p>%s</p> ", content, values[0]);
      Sleep(1000);
   }
   sprintf(content, "%sThank you for using our software.\r\n", content);
   //sprintf(content, "%s<p>nargs = %d.\r\n", content, nargs);
   sprintf(content, "%s</body>", content);
   sprintf(content, "%s</html>", content);

   /* Send the HTTP response lines, followed by a blank line */
   printf("Content-length: %d\r\n", strlen(content));
   printf("Content-type: text/html\r\n\r\n");

   /* Send the response body */
   printf("%s", content);
   fflush(stdout);

   return 0;
}
